Bug 694021 (CVE-2011-1494, CVE-2011-1495) - CVE-2011-1494 CVE-2011-1495 kernel: drivers/scsi/mpt2sas: prevent heap overflows
Summary: CVE-2011-1494 CVE-2011-1495 kernel: drivers/scsi/mpt2sas: prevent heap overflows
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2011-1494, CVE-2011-1495
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
high
high
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard: public=20110405,reported=20110406,sou...
Depends On: 694022 694023 694024 694526 694527 745793
Blocks:
TreeView+ depends on / blocked
 
Reported: 2011-04-06 09:17 UTC by Eugene Teo (Security Response)
Modified: 2019-06-08 18:47 UTC (History)
16 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-07-29 12:33:55 UTC


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2011:0542 normal SHIPPED_LIVE Important: Red Hat Enterprise Linux 6.1 kernel security, bug fix and enhancement update 2011-05-19 11:58:07 UTC
Red Hat Product Errata RHSA-2011:0833 normal SHIPPED_LIVE Important: kernel security and bug fix update 2011-05-31 14:05:42 UTC
Red Hat Product Errata RHSA-2011:0883 normal SHIPPED_LIVE Important: kernel security and bug fix update 2011-06-21 23:52:55 UTC
Red Hat Product Errata RHSA-2011:1253 normal SHIPPED_LIVE Important: kernel-rt security and bug fix update 2011-09-12 19:43:48 UTC

Description Eugene Teo (Security Response) 2011-04-06 09:17:45 UTC
At two points in handling device ioctls via /dev/mpt2ctl, user-supplied length values are used to copy data from userspace into heap buffers without bounds checking, allowing controllable heap corruption and subsequently privilege escalation.

Additionally, user-supplied values are used to determine the size of a copy_to_user() as well as the offset into the buffer to be read, with no bounds checking, allowing users to read arbitrary kernel memory.

Compile-tested only.  Thanks to Eric Moore for suggestions on how to fix this.

Acknowledgements:

Red Hat would like to thank Dan Rosenberg for reporting this issue.

Comment 5 Eugene Teo (Security Response) 2011-04-07 15:17:27 UTC
Statement:

This issue did not affect the version of Linux kernel as shipped with Red Hat
Enterprise Linux 4 as it did not provide support for MPT (Message Passing
Technology) based controllers. This has been addressed in Red Hat Enterprise Linux 5, 6, and Red Hat Enterprise MRG via https://rhn.redhat.com/errata/RHSA-2011-0833.html, and https://rhn.redhat.com/errata/RHSA-2011-0542.html, and https://rhn.redhat.com/errata/RHSA-2011-1253.html.

Comment 6 Eugene Teo (Security Response) 2011-04-08 01:13:57 UTC
I saw a couple versions of the fixes for this. Please wait for akpm to update -mm with Dan's version before backporting.

Comment 7 Eugene Teo (Security Response) 2011-04-18 02:49:58 UTC
(In reply to comment #6)
> I saw a couple versions of the fixes for this. Please wait for akpm to update
> -mm with Dan's version before backporting.

http://marc.info/?l=linux-scsi&m=130202237006310&w=2

Comment 9 errata-xmlrpc 2011-05-23 20:50:03 UTC
This issue has been addressed in following products:

  Red Hat Enterprise Linux 6

Via RHSA-2011:0542 https://rhn.redhat.com/errata/RHSA-2011-0542.html

Comment 11 errata-xmlrpc 2011-06-21 23:53:06 UTC
This issue has been addressed in following products:

  Red Hat Enterprise Linux 6.0.Z - Server Only

Via RHSA-2011:0883 https://rhn.redhat.com/errata/RHSA-2011-0883.html

Comment 12 Eugene Teo (Security Response) 2011-07-19 06:47:01 UTC
(In reply to comment #7)
> (In reply to comment #6)
> > I saw a couple versions of the fixes for this. Please wait for akpm to update
> > -mm with Dan's version before backporting.
> 
> http://marc.info/?l=linux-scsi&m=130202237006310&w=2

Upstream commit:
http://git.kernel.org/linus/a1f74ae82d133ebb2aabb19d181944b4e83e9960

Comment 13 errata-xmlrpc 2011-09-12 19:44:07 UTC
This issue has been addressed in following products:

  MRG for RHEL-6 v.2

Via RHSA-2011:1253 https://rhn.redhat.com/errata/RHSA-2011-1253.html


Note You need to log in before you can comment on or make changes to this bug.